Image Alignment Tool
(c) GreatAttractor (WielkiAtraktor)
v 0.4.1
2014/05/05

Dozwolone rozpowszechnianie i wykorzystanie w dowolny sposb bez ogranicze.


1. Wprowadzenie
  1.1 Skadnia w linii polece
  1.2 Uwagi
    1.2.1 Konwersja plikw
    1.2.2 Uruchamianie bez uycia wiersza polece (konsoli)
2. Budowanie ze rde
2.1 Budowanie za pomoc MinGW
2.2 Budowanie za pomoc Microsoft C++ (z Windows SDK bd Visual Studio/Visual C++)
2.3 Budowanie za pomoc GCC (Linux i pokrewne, MinGW+MSYS)
3 Historia zmian

----------------------------------------
1. Wprowadzenie

Imgalt jest narzdziem do wyrwnywania sekwencji obrazw, ktre mog by znacznie przesunite wzgldem siebie w przypadkowy sposb. Do obrbki przyjmowane s pliki BMP (8- lub 24-bitowe) i TIFF (8 lub 16 bitw na kana, RGB lub w odcieniach szaroci), rozmiary mog si rni. Po wyrwnaniu pliki wynikowe zapisywane s w tym samym formacie, o jednakowej wielkoci rwnej wielkoci prostokta bdcego przeciciem (najwikszym wsplnym obszarem) wszystkich obrazw wejciowych po ich wyrwnaniu. (Mona te zapisa obrazy powikszone do obejmujcego je wszystkie prostokta uywajc parametru --no-crop).

Przykadowy scenariusz uycia to przygotowanie klatek animacji w osobnym katalogu (folderze), przekazanie ich do imgalt, otwarcie wyrwnanych klatek w GIMPie (File->Open as Layers...), obrbka i przycicie (zaznaczenie obszaru, nastpnie Image->Crop to Selection) i wreszcie eksport jako animowany GIF (File->Export, wybr formatu GIF, zaznaczenie "As Animation").

  ----------------------------------------
  1.1 Skadnia w linii polece
  
Oglna posta wywoania:
  
  imgalt [--verbose] [--threads <liczba>] [--no-crop] [--output-dir <output directory>] [[--input-dir] <input directory>]
  
Katalog wejciowy jest parametrem domylnym, wic mona pomin "--input-dir". Przykady:

  imgalt c:\astro\solar
  
(wyrwnuje wszystkie pliki w c:\astro\solar i zapisuje wyrwnane w katalogu biecym).

  imgalt
  
(wyrwnuje wszystkie pliki w katalogu biecym i zapisuje wyrwnane w tym samym miejscu).

Imgalt wyrwnuje wszystkie pliki BMP i TIFF (posortowane po nazwie) w katalogu wejciowym (domylnie: biecy) i zapisuje je z przyrostkiem "_aligned" w katalogu wyjciowym (domylnie: biecy).

Parametr "--verbose" wcza wypisywanie dodatkowych informacji w trakcie wyrwnywania.

Parametr "--threads" ustawia liczb wtkw roboczych (domylnie: liczba wykrytych procesorw logicznych).

Parametr "--no-crop" powoduje powikszenie obrazw wyjciowych do rozmiaru wsplnego prostokta otaczajcego zamiast obcinania ich do najwikszego wsplnego obszaru.

Jeli katalog wejciowy lub docelowy zawieraj spacje, naley otoczy cieki znakami cudzysowu, np.:

  imgalt "c:\astro\Czerwiec 12" --output-dir "c:\astro\Czerwiec 12\aligned"

  ----------------------------------------
  1.2 Uwagi

    ----------------------------------------
    1.2.1 Konwersja plikw
    
Pliki mona szybko skonwertowa zbiorowo np. w IrfanView (File->Batch Conversion/Rename...). Animowany GIF mona rozbi na klatki np. w programie VirtualDub (otworzy plik GIF, potem File->Export->Image sequence...).
  
    ----------------------------------------
    1.2.2 Uruchamianie bez uycia wiersza polece (konsoli)
    
Jako e uruchomienie imgalt bez parametrw oznacza przyjcie katalogu (folderu) biecego jako wejciowego, mona zrobi, co nastpuje:
  - skopiowa pliki przeznaczone do wyrwnania do katalogu, gdzie znajduje si imgalt.exe
  - uruchomi imgalt.exe
Wyrwnanie pliki wyjciowe pojawi si w tym samym katalogu.

Kolejn metod (pod MS Windows, cho moe zadziaa rwnie w innych rodowiskach graficznych) jest przecignicie katalogu z plikami wejciowymi i upuszczenie go na ikon imgalt.exe. Wyrwnane pliki pojawi si w katalogu, ktry by w tym czasie biecy (np. w Windows, jeli przecignity zosta "d:\astro\sekwencja1", pliki wynikowe powinny pojawi si w "d:\astro").
  
----------------------------------------
2. Budowanie ze rde

Kod rdowy imgalt mona swobodnie rozpowszechnia i wykorzystywa w dowolnym celu. Do wybudowania ze rde potrzebne s biblioteki Boost w wersji 1.53.0 lub nowszej (starsze mog dziaa po niewielkich zmianach w kodzie imgalt). Wielowtkowo wymaga kompilatora obsugujcego OpenMP (np. GCC 4.2 lub nowsze, MS Visual C++ 2008 lub nowsze (wersje patne), MS Visual C++ 2012 Express lub nowsze).

  ----------------------------------------
  2.1 Budowanie za pomoc MinGW

Otworzy Makefile.mingw i ustawi zmienne BOOST_INCLUDE i BOOST_LIBS na odpowiednie dla uywanej instalacji Boost. Upewni si, e narzdzia MinGW s na ciece (np. wywoa "set PATH=%PATH%;c:\mingw\bin") i wykona:

    mingw32-make -f Makefile.mingw
    
  ----------------------------------------    
  2.2 Budowanie za pomoc Microsoft C++ (z Windows SDK bd Visual Studio/Visual C++)
  
Otworzy Makefile.msvc i ustawi zmienne BOOST_INCLUDE i BOOST_LIBS na odpowiednie dla uywanej instalacji Boost. Przeczyta notatk o obsudze OpenMP. Upewni si, e narzdzia MS s na ciece (np. wywoa "C:\Program Files (x86)\Microsoft Visual Studio 11.0\VC\bin\vcvars32.bat") i wykona:

    nmake -f Makefile.msvc
    
  ----------------------------------------        
  2.3 Budowanie za pomoc GCC (Linux i pokrewne, MinGW+MSYS)
  
Upewni si, e binarne i nagwkowe biblioteki Boost s zainstalowane (np. pod Linuksem zainstalowa pakiety "boost", "boost-devel") i wykona:

    make -f Makefile.gcc
    
----------------------------------------            
3. Historia zmian

0.4.1 (2014/05/05)
    Nowe funkcje:
      - obsuga plikw TIFF

0.4 (2014/05/02)
    Nowe funkcje:
      - domylne obcinanie do najwikszego wsplnego obszaru
    Poprawki bdw:
      - poprawiona translacja przy zapisie wyrwnanych obrazw, powodowaa chaotyczne 1-pikselowe skoki

0.3 (2014/04/25)
    Nowe funkcje:
      - przyjmowanie rwnie kolorowych obrazw wejciowych
      - zapis obrazw wyjciowych w tym samym formacie kolorw co wejciowe
    Poprawki bdw:
      - poprawiony zapis BMP o dugoci linii nie bdcej wielokrotnoci 4